unit adsr_graph;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, synth_functions;

type
  TEnvGraphForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    ATime: TScrollBar;
    Label2: TLabel;
    ALevel: TScrollBar;
    Label3: TLabel;
    DTime: TScrollBar;
    Label4: TLabel;
    DLevel: TScrollBar;
    Label5: TLabel;
    STime: TScrollBar;
    Label6: TLabel;
    RTime: TScrollBar;
    Bevel1: TBevel;
    GraphBox: TPaintBox;
    procedure DLevelChange(Sender: TObject);
    procedure ALevelChange(Sender: TObject);
    procedure ChangeBars(Sender: TObject);
    procedure UpdateGraph(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  EnvGraphForm: TEnvGraphForm;

implementation

{$R *.DFM}

procedure TEnvGraphForm.DLevelChange(Sender: TObject);
begin
  if DLevel.Position >= ALevel.Position then
    DLevel.Position := ALevel.Position - 5;
  ChangeBars(Sender);
end;

procedure TEnvGraphForm.ALevelChange(Sender: TObject);
begin
  if ALevel.Position < 10 then ALevel.Position := 10;
  DLevelChange(Self);
  ChangeBars(Sender);
end;

procedure TEnvGraphForm.ChangeBars(Sender: TObject);
begin
  UpdateGraph(Sender);
end;

procedure TEnvGraphForm.UpdateGraph(Sender: TObject);
var
  Bmp : TBitmap;

  Unitlen, Unitlentel : Single;
  x, y : Integer;
begin
  Bmp := TBitMap.Create;
  try
    Bmp.Width := GraphBox.Width;
    Bmp.Height := GraphBox.Height;
    with Bmp.Canvas do
    begin
      Pen.Color := clBlack;
      Brush.Color := clWhite;
      Rectangle(0,0, Bmp.Width, Bmp.Height);
      MoveTo(0, Bmp.Height -4);
      LineTo(Bmp.Width, Bmp.Height -4);

      Pen.Color := clRed;
      UnitLen    := (Bmp.Height-8);
      UnitLentel := 1/UnitLen;
      for x := 1 to Bmp.Width - 1 do
      begin
        y := (Bmp.Height - 4) - Round(ADSREnvelope(2*(x-5) * UnitLentel, 1/100*ATime.Position, 1/100*DTime.Position,
                   1/100*STime.Position, 1/100*RTime.Position,
                   1/100*ALevel.Position, 1/100*Dlevel.Position)*UnitLen);
        if x = 1 then
          MoveTo(x,y)
        else
          LineTo(x,y)
        //Pixels[x,y] := Pen.Color;
      end;

    end;
    GraphBox.Canvas.Draw(0,0, Bmp);
  finally
    Bmp.Free;
  end;
end;

end.
